// WARNING! All changes made in this file will be lost!
// Created from 'info.style' by 'codegen_style'
//
// This file is part of Desktop App Toolkit,
// a set of libraries for developing nice desktop applications.
//
// For license and copyright information please follow this link:
// https://github.com/desktop-app/legal/blob/master/LEGAL
//
#pragma once

#include "ui/style/style_core.h"

#include "styles/style_widgets.h"
#include "styles/style_boxes.h"

namespace style {
namespace internal {

void init_style_info(int scale);

} // namespace internal

struct SearchFieldRow;
struct IconButton;
struct FlatLabel;
struct RoundButton;
struct UserpicButton;
struct Toggle;
struct SettingsButton;
struct PeerList;
struct InputField;
struct CrossButton;
struct TextStyle;
struct PeerListItem;
struct SettingsCountButton;
struct Checkbox;
struct InfiniteRadialAnimation;
struct GroupCallUserpics;
struct ScrollArea;

struct InfoToggle {
	style::color color;
	int duration;
	int size;
	int skip;
	int stroke;
	int rippleAreaPadding;
};

struct InfoPeerBadge {
	style::icon verified;
	style::icon premium;
	style::color premiumFg;
	style::point position;
	int sizeTag;
};

struct InfoTopBar {
	int height;
	style::IconButton back;
	style::FlatLabel title;
	style::point titlePosition;
	style::FlatLabel titleWithSubtitle;
	style::point titleWithSubtitlePosition;
	style::FlatLabel subtitle;
	style::point subtitlePosition;
	style::color bg;
	style::IconButton mediaCancel;
	int mediaActionsSkip;
	style::IconButton mediaForward;
	style::IconButton mediaDelete;
	style::IconButton storiesSave;
	style::IconButton storiesArchive;
	style::IconButton storiesPin;
	style::IconButton storiesUnpin;
	style::IconButton search;
	style::SearchFieldRow searchRow;
	style::color highlightBg;
	int highlightDuration;
	int radius;
};

struct InfoProfileCover {
	int height;
	style::UserpicButton photo;
	int photoLeft;
	int photoTop;
	style::FlatLabel name;
	int nameLeft;
	int nameTop;
	style::FlatLabel status;
	int statusLeft;
	int statusTop;
	style::RoundButton showLastSeen;
	style::point showLastSeenPosition;
	bool showLastSeenVisible;
	int rightSkip;
};

struct ShortInfoCover {
	int size;
	int radius;
	style::FlatLabel name;
	style::point namePosition;
	style::FlatLabel status;
	style::point statusPosition;
	int linePadding;
	int lineSkip;
	int line;
	int shadowHeight;
	style::InfiniteRadialAnimation radialAnimation;
};

} // namespace style

namespace st {
extern const style::color &infoMediaHeaderFg;
extern const style::InfoToggle &infoToggle;
extern const style::SearchFieldRow &infoMediaSearch;
extern const style::SearchFieldRow &infoLayerMediaSearch;
extern const style::SearchFieldRow &infoTopBarSearchRow;
constexpr int infoSlideDuration = 0;
extern const style::icon &infoTopBarBackIcon;
extern const style::icon &infoTopBarBackIconOver;
extern const int &infoTopBarHeight;
extern const style::IconButton &infoTopBarBack;
extern const style::FlatLabel &infoTopBarTitle;
extern const style::IconButton &infoTopBarMediaCancel;
extern const style::IconButton &infoTopBarClose;
extern const style::IconButton &infoTopBarSearch;
extern const style::IconButton &infoTopBarMenu;
extern const style::IconButton &infoTopBarCall;
extern const style::IconButton &infoTopBarQr;
extern const style::IconButton &infoTopBarEdit;
extern const style::IconButton &infoTopBarForward;
extern const style::IconButton &infoTopBarDelete;
extern const style::IconButton &infoTopBarSaveStories;
extern const style::IconButton &infoTopBarArchiveStories;
extern const style::IconButton &infoTopBarPinStories;
extern const style::IconButton &infoTopBarUnpinStories;
extern const style::InfoTopBar &infoTopBar;
constexpr double infoTopBarScale = 0.7;
constexpr int infoTopBarDuration = 150;
extern const int &infoLayerTopMinimal;
extern const int &infoLayerTopMaximal;
extern const int &infoLayerTopBarHeight;
extern const style::icon &infoLayerTopBarBackIcon;
extern const style::icon &infoLayerTopBarBackIconOver;
extern const style::IconButton &infoLayerTopBarBack;
extern const style::IconButton &infoLayerTopBarMediaCancel;
extern const style::IconButton &infoLayerTopBarClose;
extern const style::IconButton &infoLayerTopBarMenu;
extern const style::IconButton &infoLayerTopBarCall;
extern const style::IconButton &infoLayerTopBarQr;
extern const style::IconButton &infoLayerTopBarEdit;
extern const style::IconButton &infoLayerTopBarForward;
extern const style::IconButton &infoLayerTopBarDelete;
extern const style::IconButton &infoLayerTopBarSaveStories;
extern const style::IconButton &infoLayerTopBarArchiveStories;
extern const style::IconButton &infoLayerTopBarPinStories;
extern const style::IconButton &infoLayerTopBarUnpinStories;
extern const style::InfoTopBar &infoLayerTopBar;
extern const style::point &infoLayerTopBarMenuPosition;
extern const int &infoMinimalWidth;
extern const int &infoDesiredWidth;
extern const int &infoMinimalLayerMargin;
extern const int &infoProfilePhotoInnerSize;
extern const style::size &infoProfilePhotoSize;
extern const style::FlatLabel &infoProfileStatus;
extern const style::InfoProfileCover &infoProfileCover;
extern const style::InfoProfileCover &infoProfileMegagroupCover;
extern const style::InfoProfileCover &infoTopicCover;
extern const style::InfoProfileCover &infoEditContactCover;
extern const int &infoEditContactPersonalLeft;
extern const style::icon &infoProfileInaccessibleUserpic;
extern const style::point &infoVerifiedCheckPosition;
extern const style::icon &infoVerifiedCheck;
extern const style::icon &infoPremiumStar;
extern const style::InfoPeerBadge &infoPeerBadge;
extern const style::color &infoIconFg;
extern const int &infoProfileSkip;
extern const style::margins &infoProfileLabeledPadding;
extern const style::margins &infoProfileLabeledUsernamePadding;
extern const style::margins &infoProfileSeparatorPadding;
extern const style::IconButton &infoProfileLabeledButtonQr;
extern const int &infoProfileLabeledButtonQrRightSkip;
extern const style::icon &infoIconInformation;
extern const style::icon &infoIconAddMember;
extern const style::icon &infoIconBotBalance;
extern const style::icon &infoIconNotifications;
extern const style::icon &infoIconMediaPhoto;
extern const style::icon &infoIconMediaVideo;
extern const style::icon &infoIconMediaGif;
extern const style::icon &infoIconMediaFile;
extern const style::icon &infoIconMediaAudio;
extern const style::icon &infoIconMediaLink;
extern const style::icon &infoIconMediaGroup;
extern const style::icon &infoIconMediaChannel;
extern const style::icon &infoIconMediaVoice;
extern const style::icon &infoIconMediaStories;
extern const style::icon &infoIconMediaSaved;
extern const style::icon &infoIconMediaStoriesArchive;
extern const style::icon &infoIconMediaStoriesRecent;
extern const style::icon &infoIconMediaGifts;
extern const style::icon &infoIconEmojiStatusAccess;
extern const style::icon &infoIconShare;
extern const style::icon &infoIconEdit;
extern const style::icon &infoIconDelete;
extern const style::icon &infoIconDeleteRed;
extern const style::icon &infoIconReport;
extern const style::icon &infoIconLeave;
extern const style::icon &infoIconBlock;
extern const style::icon &infoIconMembers;
extern const style::point &infoInformationIconPosition;
extern const style::point &infoNotificationsIconPosition;
extern const style::point &infoSharedMediaButtonIconPosition;
extern const style::point &infoGroupMembersIconPosition;
extern const style::point &infoChannelMembersIconPosition;
extern const style::point &infoChannelAdminsIconPosition;
extern const style::point &infoEarnCreditsIconPosition;
extern const style::point &infoEarnCurrencyIconPosition;
extern const style::RoundButton &infoOpenApp;
extern const style::margins &infoOpenAppMargin;
extern const style::point &infoPersonalChannelIconPosition;
extern const style::FlatLabel &infoPersonalChannelNameLabel;
extern const int &infoPersonalChannelDateSkip;
extern const style::FlatLabel &infoPersonalChannelDateLabel;
extern const int &infoPersonalChannelUserpicSkip;
extern const style::UserpicButton &infoPersonalChannelUserpic;
extern const style::FlatLabel &infoBlockHeaderLabel;
extern const style::point &infoBlockHeaderPosition;
extern const style::Toggle &infoProfileToggle;
extern const style::Toggle &infoProfileToggleOver;
extern const style::SettingsButton &infoProfileButton;
extern const style::SettingsButton &infoNotificationsButton;
extern const style::SettingsButton &infoMainButton;
extern const style::SettingsButton &infoMainButtonAttention;
extern const style::SettingsButton &infoSharedMediaButton;
extern const int &infoSharedMediaBottomSkip;
extern const style::SettingsButton &infoBlockButton;
extern const style::SettingsButton &infoCreateLinkedChatButton;
extern const style::SettingsButton &infoUnlinkChatButton;
extern const int &infoBlockButtonSkip;
extern const int &infoMembersHeader;
extern const style::PeerList &infoMembersList;
extern const style::point &infoMembersButtonPosition;
extern const style::IconButton &infoMembersButton;
extern const style::IconButton &infoMembersAddMember;
extern const style::IconButton &infoMembersSearch;
extern const style::InputField &infoMembersSearchField;
extern const style::CrossButton &infoMembersCancelSearch;
extern const int &infoMembersSearchTop;
extern const style::TextStyle &infoMediaHeaderStyle;
extern const int &infoMediaHeaderHeight;
extern const style::point &infoMediaHeaderPosition;
extern const int &infoMediaSkip;
extern const int &infoMediaLeft;
extern const style::margins &infoMediaMargin;
extern const int &infoMediaMinGridSize;
extern const style::margins &infoCommonGroupsMargin;
extern const style::PeerListItem &infoCommonGroupsListItem;
extern const style::PeerList &infoCommonGroupsList;
extern const style::SettingsCountButton &managePeerButton;
extern const style::SettingsCountButton &peerPermissionsButton;
extern const style::SettingsButton &manageGroupButtonInner;
extern const style::SettingsCountButton &manageGroupButton;
extern const style::SettingsCountButton &infoSharedMediaCountButton;
extern const style::SettingsCountButton &manageGroupTopButtonWithText;
extern const style::SettingsCountButton &manageGroupTopicsButton;
extern const style::SettingsButton &managePeerColorsButton;
extern const style::SettingsButton &manageGroupNoIconButtonInner;
extern const style::SettingsCountButton &manageGroupNoIconButton;
extern const style::SettingsCountButton &manageDeleteGroupButton;
extern const style::IconButton &manageGroupReactions;
extern const style::InputField &manageGroupReactionsField;
extern const style::margins &manageGroupReactionsFieldPadding;
extern const int &manageGroupReactionsTextSkip;
extern const style::margins &manageGroupReactionsMaxSubtitlePadding;
extern const style::color &infoEmptyFg;
extern const style::icon &infoEmptyPhoto;
extern const style::icon &infoEmptyVideo;
extern const style::icon &infoEmptyAudio;
extern const style::icon &infoEmptyFile;
extern const style::icon &infoEmptyVoice;
extern const style::icon &infoEmptyLink;
extern const style::icon &infoEmptyStories;
extern const int &infoEmptyIconTop;
extern const int &infoEmptyLabelTop;
extern const int &infoEmptyLabelSkip;
extern const style::FlatLabel &infoEmptyLabel;
extern const style::FlatLabel &infoStoriesAboutArchive;
extern const style::margins &infoStoriesAboutArchivePadding;
extern const style::margins &editPeerBottomButtonsLayoutMargins;
extern const int &editPeerTopButtonsLayoutSkip;
extern const int &editPeerTopButtonsLayoutSkipToBottom;
extern const int &editPeerTopButtonsLayoutSkipCustomBottom;
extern const int &editPeerHistoryVisibilityTopSkip;
extern const style::margins &editPeerPhotoMargins;
extern const style::InputField &editPeerTitle;
extern const style::margins &editPeerTitleMargins;
extern const style::point &editPeerTitleEmojiPosition;
extern const style::InputField &editPeerTitleField;
extern const style::InputField &editPeerDescription;
extern const style::margins &editPeerDescriptionMargins;
extern const style::margins &editPeerPrivaciesMargins;
extern const int &editPeerPrivacyBottomSkip;
extern const style::FlatLabel &editPeerPrivacyLabel;
extern const style::Checkbox &editPeerPrivacyBoxCheckbox;
extern const style::margins &editPeerPrivacyLabelMargins;
extern const style::margins &editPeerPreHistoryLabelMargins;
extern const style::margins &editPeerUsernameFieldMargins;
extern const style::InputField &editPeerUsername;
extern const style::FlatLabel &editPeerUsernameGood;
extern const int &editPeerReactionsPreview;
extern const int &editPeerReactionsIconLeft;
extern const style::IconButton &historyTopBarBack;
extern const int &topBarHeight;
extern const style::point &topBarMenuPosition;
extern const int &topBarMenuGroupCallSkip;
extern const style::icon &topBarBack;
extern const style::margins &topBarArrowPadding;
extern const int &topBarNameRightPadding;
extern const style::RoundButton &topBarButton;
extern const style::RoundButton &topBarClearButton;
extern const style::IconButton &topBarSearch;
extern const style::IconButton &topBarCloseChoose;
extern const int &topBarSkip;
extern const int &topBarCallSkip;
extern const style::IconButton &topBarMenuToggle;
extern const style::IconButton &topBarCall;
extern const style::IconButton &topBarGroupCall;
extern const style::IconButton &topBarInfo;
extern const style::IconButton &topBarRecentActions;
extern const style::IconButton &topBarAdmins;
extern const style::icon &topBarInfoActive;
extern const int &topBarActionSkip;
extern const style::size &topBarInfoButtonSize;
extern const int &topBarInfoButtonInnerSize;
extern const style::point &topBarInfoButtonInnerPosition;
extern const style::UserpicButton &topBarInfoButton;
extern const style::point &topBarConnectingPosition;
extern const int &topBarConnectingSkip;
extern const style::InfiniteRadialAnimation &topBarConnectingAnimation;
extern const style::FlatLabel &inviteLinkTitleRight;
extern const int &inviteLinkFieldRadius;
extern const int &inviteLinkFieldHeight;
extern const style::margins &inviteLinkFieldMargin;
extern const style::icon &inviteLinkThreeDotsIcon;
extern const style::icon &inviteLinkThreeDotsIconOver;
extern const style::IconButton &inviteLinkThreeDots;
extern const style::margins &inviteLinkFieldPadding;
extern const style::FlatLabel &inviteLinkFieldLabel;
extern const style::RoundButton &inviteLinkButton;
extern const style::margins &inviteLinkButtonsPadding;
extern const int &inviteLinkButtonsSkip;
extern const style::RoundButton &inviteLinkCopy;
extern const style::RoundButton &inviteLinkShare;
extern const style::RoundButton &inviteLinkReactivate;
extern const style::RoundButton &inviteLinkDelete;
extern const style::GroupCallUserpics &inviteLinkUserpics;
extern const int &inviteLinkUserpicsSkip;
extern const style::font &inviteLinkJoinedFont;
extern const style::margins &inviteLinkJoinedRowPadding;
extern const int &inviteLinkCreateSkip;
extern const style::SettingsButton &inviteLinkCreate;
extern const style::icon &inviteLinkCreateIcon;
extern const int &inviteLinkCreateIconSize;
extern const style::PeerListItem &inviteLinkListItem;
extern const style::PeerList &inviteLinkList;
extern const style::PeerList &inviteLinkChatList;
extern const style::PeerList &inviteLinkAdminsList;
extern const int &inviteLinkIconSkip;
extern const int &inviteLinkIconStroke;
extern const style::icon &inviteLinkIcon;
extern const style::icon &inviteLinkRevokedIcon;
extern const int &inviteLinkThreeDotsSkip;
extern const style::margins &inviteLinkRevokedTitlePadding;
extern const style::margins &inviteLinkLimitMargin;
extern const int &inviteLinkSubscriptionSize;
extern const int &inviteLinkQrPixel;
extern const int &inviteLinkQrSkip;
extern const style::margins &inviteLinkQrMargin;
extern const style::margins &inviteLinkQrValuePadding;
extern const style::InputField &inviteLinkCreditsField;
extern const style::FlatLabel &inviteLinkSubscribeBoxTitle;
extern const style::FlatLabel &inviteLinkSubscribeBoxAbout;
extern const style::FlatLabel &inviteLinkSubscribeBoxTerms;
extern const style::icon &usernamesReorderIcon;
extern const style::FlatLabel &infoAboutGigagroup;
constexpr int infoScrollDateHideTimeout = 1000;
constexpr int infoDateFadeDuration = 200;
extern const int &shortInfoWidth;
extern const style::margins &shortInfoLabeledPadding;
extern const style::ScrollArea &shortInfoScroll;
extern const style::ShortInfoCover &shortInfoCover;
extern const style::icon &permissionsExpandIcon;
extern const int &similarChannelsLockOverlap;
extern const int &similarChannelsLockFade;
extern const style::RoundButton &similarChannelsLock;
extern const style::FlatLabel &similarChannelsLockLabel;
extern const style::margins &similarChannelsLockPadding;
extern const style::FlatLabel &similarChannelsLockAbout;
extern const style::margins &similarChannelsLockAboutPadding;
extern const style::FlatLabel &infoHoursState;
extern const style::FlatLabel &infoHoursValue;
extern const style::FlatLabel &infoHoursDayLabel;
extern const style::RoundButton &infoHoursOuter;
extern const style::margins &infoHoursOuterMargin;
extern const int &infoHoursDaySkip;
extern const style::ScrollArea &infoSharedMediaScroll;
} // namespace st
